Subject: Re: __cpu_up vs. start_secondary race?

From: Benjamin Herrenschmidt <[email-masked]>
Date: Wed, 03 Dec 2008 15:52:43 +1100

On Tue, 2008-12-02 at 20:16 -0600, Nathan Lynch wrote:
> Apart from barriers (or lack thereof), the fact that __cpu_up gives up
> after a more-or-less arbitrary period seems... well, arbitrary.  If we
> get to "Processor X is stuck" then something is seriously wrong:
> there's either a kernel bug or a platform issue, and the CPU just
> kicked is in an unknown state.  Polling indefinitely seems safer, no?
> Especially since some hypervisors allow overcommitting processors and
> memory, which can introduce latencies in unexpected places.

I'm pretty happy to keep the timeout :-) Proved useful in many cases
where we actually fail to bring it up or crash it at bringup. From my
experience, most of the time, the stuck CPU isn't getting in the way and
it gets us a chance to move forward.

Ben.